package schedframe.resources.computing.profiles.energy.thermal;

import java.util.ArrayList;
import java.util.List;

import org.joda.time.DateTimeUtils;

import schedframe.Parameters;

public class ThermalProfile {
	
	protected List<TemperatureValue> temperatureHistory;
	protected Parameters parameters;

	public ThermalProfile() {
		super();

		this.temperatureHistory = new ArrayList<TemperatureValue>();
	}

	public void addToTemperatureHistory(double temperature) {

		if (temperatureHistory.size() == 0) {
			TemperatureValue usage = new TemperatureValue(DateTimeUtils.currentTimeMillis(), temperature);
			temperatureHistory.add(usage);
			return;
		}

		int lastIdx = temperatureHistory.size() - 1;
		double lastTemperature = temperatureHistory.get(lastIdx).getValue();
		if (lastTemperature != temperature) {
			TemperatureValue usage = temperatureHistory.get(lastIdx);
			long currentTime = DateTimeUtils.currentTimeMillis();
			if (usage.getTimestamp() == currentTime) {
				usage.setValue(temperature);
				if(lastIdx > 0 && temperatureHistory.get(lastIdx - 1).getValue() == temperature)
					temperatureHistory.remove(usage);
			} else {
				usage = new TemperatureValue(DateTimeUtils.currentTimeMillis(), temperature);
				temperatureHistory.add(usage);
			}
		}
	}

	public List<TemperatureValue> getTemperatureHistory() {
		return temperatureHistory;
	}
	
	public void init(Parameters params){
		this.parameters = params;
	}

	public Parameters getParameters() {
		return parameters;
	}
}
