package simulator.workload.reader.archive;

import java.io.IOException;
import java.util.HashMap;

import simulator.workload.exceptons.NoSuchCommentException;

/**
 * 
 * @author Marcin Krystek
 *
 */

public interface WAParser {
	
	public HashMap<String, String> loadHeader() throws IOException;
	
	public HashMap<String, String[]> getIDMapping();
	
	public String[] getIDMapping(String waID);
	
	public boolean isHeaderLoaded() throws IOException;
	
	public String[] readTask() throws IOException;
	
	public String[] readTask(String taskId) throws IOException;
	
	public String[] readTask(String jobID, String taskId) throws IOException;
	
	public String getCommentValue(String label) throws NoSuchCommentException;
	
	public String getDataField(int field) throws NoSuchFieldException;
	
	public String setCommentSign(String comment) ;
	
	public String setFieldSeparator(String fieldSeparator) ;

	public void reset() throws IOException;
	
	public void close() throws IOException;
	
	public String getFileName();
	
	public int getType();
}
