package simulator.workload.reader.xmlJob;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FilenameFilter;
import java.io.IOException;

import simulator.workload.fileFilters.QcgJobFileNameFilter;

/**
 * 
 * @author Marcin Krystek
 *
 */
public class DirReader implements WLFileAccess {

	protected File files[];
	protected int currentPosition;
	
	public DirReader(File dir){
		FilenameFilter fileNameFilter = new QcgJobFileNameFilter();
		this.files = dir.listFiles(fileNameFilter);
		
		this.currentPosition = -1;
	}
	
	public String getFileName() {
		if(currentPosition >= this.files.length || currentPosition < 0)
			return null;
		
		return this.files[currentPosition].getAbsolutePath();
	}

	public String read() throws IOException {
		currentPosition++;
		
		if(currentPosition >= files.length)
			return null;
		
		BufferedReader reader = null;
		StringBuffer buffer = new StringBuffer();

		try {
			reader = new BufferedReader(new FileReader(files[currentPosition]));
			String line = null;
			
			while((line = reader.readLine()) != null){
				buffer.append(line);
			}
			
		} finally{
			reader.close();
		}
		
		return buffer.toString();
	}

	public void close() {
		
	}
}
