<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<!-- Specification of the output document -->
	<xsl:output method="xml" version="1.0" encoding="UTF-8"
		indent="yes" />

	<xsl:template match="/">
		<xsl:apply-templates select="environment"/>
	</xsl:template>

	<xsl:template match="environment">
		<xsl:copy >
			<xsl:copy-of select="@*" />
			<xsl:apply-templates select="resources"/>	
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="resources">
		<xsl:copy copy-namespaces="no">
			<xsl:apply-templates select="//resources/computingResource" />
			<xsl:copy-of select="scheduler"/>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="computingResource">
		<xsl:copy copy-namespaces="no">
			<xsl:copy-of select="@*" />
			<!-- Find nested elements in appropriate order and copy them -->
			<!-- resourceUnit -->
			<xsl:apply-templates select="resourceUnit" />
			<!-- parameter -->
			<xsl:apply-templates select="parameter" />
			<!-- profile -->
			<xsl:apply-templates select="profile" />
			<!-- location -->
			<xsl:apply-templates select="location" />
			<!-- computingResource -->
			<xsl:apply-templates select="computingResource" />
		</xsl:copy>
	</xsl:template>

	<xsl:template match="resourceUnit | parameter | profile | location">
		<xsl:copy-of select="." copy-namespaces="no" />
	</xsl:template>
<!--	<xsl:template match="parameter">-->
<!--		<xsl:copy-of select="." copy-namespaces="no" />-->
<!--	</xsl:template>-->
<!--	<xsl:template match="profile">-->
<!--		<xsl:copy-of select="." copy-namespaces="no" />-->
<!--	</xsl:template>-->
<!--	<xsl:template match="location">-->
<!--		<xsl:copy-of select="." copy-namespaces="no" />-->
<!--	</xsl:template>-->

</xsl:stylesheet>